var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { FaTimes } from 'react-icons/fa';
var Filter = function (_a) {
    var parameters = _a.parameters, onApply = _a.onApply, onClose = _a.onClose, initialFilters = _a.initialFilters;
    var _b = React.useState({}), filterValues = _b[0], setFilterValues = _b[1];
    var _c = React.useState({}), errors = _c[0], setErrors = _c[1];
    React.useEffect(function () {
        if (initialFilters) {
            setFilterValues(initialFilters);
        }
    }, [initialFilters]);
    var validateField = function (parameter, value) {
        var _a;
        if (((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) && !value) {
            return 'Trường này là bắt buộc';
        }
        return '';
    };
    var hasEmptyRequiredFields = function () {
        return parameters.some(function (parameter) {
            var _a;
            return ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) &&
                (filterValues[parameter.code] === undefined ||
                    filterValues[parameter.code] === '' ||
                    filterValues[parameter.code] === null);
        });
    };
    var handleClearValue = function (code) {
        setFilterValues(function (param) {
            var _a;
            return (__assign(__assign({}, param), (_a = {}, _a[code] = undefined, _a)));
        });
    };
    var handleInputChange = function (code, value, dataType) {
        var parsedValue = value || '';
        switch (dataType) {
            case 'integer':
                parsedValue = parseInt(value);
                break;
            case 'double':
                parsedValue = parseFloat(value);
                break;
            case 'boolean':
                parsedValue = Boolean(value);
                break;
            case 'datetime':
                parsedValue = new Date(value).toISOString();
                break;
            default:
                parsedValue = value;
        }
        setFilterValues(function (param) {
            var _a;
            return (__assign(__assign({}, param), (_a = {}, _a[code] = parsedValue, _a)));
        });
        setErrors(function (param) {
            var _a;
            return (__assign(__assign({}, param), (_a = {}, _a[code] = '', _a)));
        });
    };
    var handleApply = function () {
        var newErrors = {};
        var hasErrors = false;
        parameters.forEach(function (parameter) {
            var error = validateField(parameter, filterValues[parameter.code]);
            if (error) {
                newErrors[parameter.code] = error;
                hasErrors = true;
            }
        });
        setErrors(newErrors);
        if (!hasErrors) {
            onApply(filterValues);
        }
    };
    var renderInput = function (parameter) {
        var value = parameter.code
            ? filterValues[parameter.code] !== undefined
                ? filterValues[parameter.code]
                : parameter.default || ''
            : '';
        var error = parameter.code ? errors[parameter.code] : '';
        var inputPropsClass = {
            className: "filter-input ".concat(error ? 'filter-input--error' : ''),
            'aria-invalid': !!error,
        };
        var renderField = function () {
            var showClearButton = value !== '' && value !== false;
            var clearButton = showClearButton ? (_jsx("button", { type: "button", className: "clear-button", onClick: function () { return handleClearValue(parameter.code); }, "aria-label": "Clear value", style: { position: 'absolute', right: '10px', top: '12px', cursor: 'pointer' }, children: _jsx(FaTimes, { size: 15, style: { display: 'block' } }) })) : null;
            switch (parameter.input_type) {
                case 'number':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "number", value: value, onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
                case 'checkbox':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "checkbox", checked: !!value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.checked, parameter.data_type);
                            } })) }));
                case 'date':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "date", value: value, onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
                case 'datetime':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "datetime-local", value: value, onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
                case 'dropdown':
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("select", __assign({}, inputPropsClass, { value: value, onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                }, children: _jsx("option", { value: "", children: "Select..." }) })), clearButton] }));
                default:
                    return (_jsxs("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: [_jsx("input", __assign({}, inputPropsClass, { type: "text", value: value, onChange: function (e) {
                                    return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                                } })), clearButton] }));
            }
        };
        return (_jsxs("div", { className: "filter-input-item", children: [renderField(), error && _jsx("p", { className: "filter-error", children: error })] }));
    };
    return (_jsx("div", { className: "filter-overlay", children: _jsxs("div", { className: "filter-modal", children: [_jsxs("div", { className: "filter-modal__header", style: { display: 'flex', justifyContent: 'space-between', alignItems: 'center' }, children: [_jsx("p", { className: "filter-modal__header--text", children: "L\u1ECDc d\u1EEF li\u1EC7u" }), _jsx("button", { className: "filter-modal__header--btn-close", disabled: hasEmptyRequiredFields(), onClick: onClose, children: _jsx(FaTimes, { size: 30, style: { display: 'block' } }) })] }), _jsx("div", { className: "filter-content", children: (parameters === null || parameters === void 0 ? void 0 : parameters.length) > 0 &&
                        parameters.map(function (parameter) {
                            var _a;
                            return (_jsxs("div", { className: "filter-item", children: [_jsxs("label", { children: [parameter.label || parameter.code, ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) && _jsx("span", { className: "required", children: "*" })] }), renderInput(parameter)] }, parameter.code));
                        }) }), _jsx("div", { className: "filter-actions", children: _jsx("button", { className: "btn btn__primary filter-actions__accept", onClick: handleApply, children: "L\u1ECDc d\u1EEF li\u1EC7u" }) })] }) }));
};
export default Filter;
